ENTRY(__reset)

/* Section Definitions */
SECTIONS
{
	.boot 0x40000000:
	{
		__boot__ = . ;
		*(.boot)				/* vectors */
	} > RAM

	.text 0x40000200:			/* bootloader needs 0x120-0x1FF */
	{
		*startup.o (.text)		/* eases debugging */
		*(.text)				/* remaining code */
		*(.text.*)
		*(.gnu.linkonce.t.*)
		*(.glue_7)
		*(.glue_7t)
		*(.gcc_except_table)
		*(.rodata)				/* read-only data (constants) */
		*(.rodata.*)
		*(.gnu.linkonce.r.*)
	} > RAM

	. = ALIGN(2);
  
	.ctors :
	{
		__ctors_start__ = . ;
		KEEP(*(SORT(.ctors.*)))
		KEEP(*(.ctors))
		__ctors_end__ = . ;
	} >RAM
	
    . = ALIGN(2);
	
	_etext = . ;
	PROVIDE (etext = .);

    . = ALIGN(2);
	
	.data :
	{
		_data = .;
		*(.data)
		*(.data.*)
	} > RAM

	. = ALIGN(2);
	_edata = . ;
	PROVIDE (edata = .);

	.bss (NOLOAD) :
	{
		__bss_start = . ;
		__bss_start__ = . ;
		*(.bss)
		*(.bss.*)
		*(COMMON)
		. = ALIGN(4);
	} > RAM

	. = ALIGN(2);
	__bss_end__ = . ;
	PROVIDE (__bss_end = .);

	_end = . ;
	PROVIDE (end = .);

	/* placed beyond all data symbols, since destructors are not used */
	.dtors (NOLOAD) :
	{
		*(.dtors)
	} >RAM
  
	/* Stabs debugging sections.  */
	.stab          0 : { *(.stab) }
	.stabstr       0 : { *(.stabstr) }
	.stab.excl     0 : { *(.stab.excl) }
	.stab.exclstr  0 : { *(.stab.exclstr) }
	.stab.index    0 : { *(.stab.index) }
	.stab.indexstr 0 : { *(.stab.indexstr) }
	.comment       0 : { *(.comment) }
	/* DWARF debug sections.
       Symbols in the DWARF debugging sections are relative to the beginning
       of the section so we begin them at 0.  */
	/* DWARF 1 */
	.debug          0 : { *(.debug) }
	.line           0 : { *(.line) }
	/* GNU DWARF 1 extensions */
	.debug_srcinfo  0 : { *(.debug_srcinfo) }
	.debug_sfnames  0 : { *(.debug_sfnames) }
	/* DWARF 1.1 and DWARF 2 */
	.debug_aranges  0 : { *(.debug_aranges) }
	.debug_pubnames 0 : { *(.debug_pubnames) }
	/* DWARF 2 */
	.debug_info     0 : { *(.debug_info .gnu.linkonce.wi.*) }
	.debug_abbrev   0 : { *(.debug_abbrev) }
	.debug_line     0 : { *(.debug_line) }
	.debug_frame    0 : { *(.debug_frame) }
	.debug_str      0 : { *(.debug_str) }
	.debug_loc      0 : { *(.debug_loc) }
	.debug_macinfo  0 : { *(.debug_macinfo) }
	/* SGI/MIPS DWARF 2 extensions */
	.debug_weaknames 0 : { *(.debug_weaknames) }
	.debug_funcnames 0 : { *(.debug_funcnames) }
	.debug_typenames 0 : { *(.debug_typenames) }
	.debug_varnames  0 : { *(.debug_varnames) }
}
